#include "model.h"
#include "looptools.h"
#include "renconst.h"

	double precision S, T, U
	common /kinvars/ S, T, U

	integer Hel1, Hel2, Hel3, Hel4
	common /kinvars/ Hel1, Hel2, Hel3, Hel4

	double complex Pair11, Pair12, Pair7, Pair6, Pair8, Pair10
	double complex Pair9, Pair5, Pair3, Pair4, Pair1, Pair2, Eps29
	double complex Eps30, Eps9, Eps25, Eps10, Eps6, Eps3, Eps7
	double complex Eps11, Eps4, Eps12, Eps8, Eps20, Eps21, Eps18
	double complex Eps23, Eps24, Eps19, Eps22, Eps1, Eps2, Eps5
	double complex Eps28, Eps26, Eps13, Eps14, Eps27, Eps16, Eps17
	double complex Eps15, Abb105, Abb112, Abb142, Abb117, Abb34
	double complex Abb68, Abb70, Abb54, Abb137, Abb92, Abb170
	double complex Abb136, Abb99, Abb115, Abb17, Abb28, Abb33
	double complex Abb50, Abb141, Abb76, Abb161, Abb140, Abb39
	double complex Abb58, Abb118, Abb56, Abb106, Abb113, Abb143
	double complex Abb52, Abb63, Abb21, Abb1, Abb26, Abb11, Abb132
	double complex Abb81, Abb130, Abb2, Abb87, Abb133, Abb144
	double complex Abb3, Abb8, Abb89, Abb14, Abb135, Abb82, Abb134
	double complex Abb4, Abb111, Abb154, Abb114, Abb107, Abb145
	double complex Abb146, Abb108, Abb122, Abb83, Abb37, Abb49
	double complex Abb73, Abb75, Abb158, Abb98, Abb174, Abb175
	double complex Abb25, Abb38, Abb45, Abb121, Abb159, Abb79
	double complex Abb181, Abb178, Abb42, Abb61, Abb47, Abb66
	double complex Abb5, Abb103, Abb12, Abb148, Abb94, Abb150
	double complex Abb23, Abb96, Abb32, Abb167, Abb169, Abb102
	double complex Abb125, Abb36, Abb48, Abb72, Abb74, Abb139
	double complex Abb84, Abb97, Abb173, Abb138, Abb24, Abb20
	double complex Abb44, Abb119, Abb77, Abb162, Abb176, Abb40
	double complex Abb59, Abb46, Abb64, Abb22, Abb30, Abb93
	double complex Abb165, Abb6, Abb95, Abb15, Abb152, Abb104
	double complex Abb155, Abb101, Abb123, Abb85, Abb126, Abb86
	double complex Abb10, Abb128, Abb147, Abb9, Abb127, Abb129
	double complex Abb91, Abb35, Abb69, Abb71, Abb55, Abb157
	double complex Abb171, Abb172, Abb100, Abb116, Abb18, Abb29
	double complex Abb19, Abb51, Abb57, Abb53, Abb7, Abb110
	double complex Abb131, Abb88, Abb27, Abb90, Abb166, Abb109
	double complex Abb160, Abb80, Abb179, Abb43, Abb62, Abb67
	double complex Abb13, Abb149, Abb151, Abb168, Abb120, Abb180
	double complex Abb78, Abb163, Abb177, Abb41, Abb60, Abb65
	double complex Abb31, Abb164, Abb16, Abb153, Abb156, Abb124
	double complex AbbSum138, AbbSum127, AbbSum154, AbbSum44
	double complex AbbSum131, AbbSum148, AbbSum144, AbbSum10
	double complex AbbSum7, AbbSum147, AbbSum24, AbbSum29
	double complex AbbSum13, AbbSum12, AbbSum9, AbbSum11, AbbSum45
	double complex AbbSum43, AbbSum38, AbbSum37, AbbSum35
	double complex AbbSum36, AbbSum16, AbbSum14, AbbSum15, AbbSum8
	double complex AbbSum3, AbbSum34, AbbSum51, AbbSum49, AbbSum50
	double complex AbbSum47, AbbSum28, AbbSum152, AbbSum151
	double complex AbbSum136, AbbSum56, AbbSum134, AbbSum149
	double complex AbbSum150, AbbSum125, AbbSum132, AbbSum135
	double complex AbbSum133, AbbSum54, AbbSum55, AbbSum52
	double complex AbbSum76, AbbSum126, AbbSum26, AbbSum27
	double complex AbbSum137, AbbSum153, AbbSum145, AbbSum146
	double complex AbbSum75, AbbSum74, AbbSum73, AbbSum112
	double complex AbbSum70, AbbSum72, AbbSum71, AbbSum69
	double complex AbbSum68, AbbSum33, AbbSum61, AbbSum109
	double complex AbbSum60, AbbSum58, AbbSum59, AbbSum31
	double complex AbbSum32, AbbSum57, AbbSum77, AbbSum46
	double complex AbbSum121, AbbSum128, AbbSum101, AbbSum81
	double complex AbbSum119, AbbSum96, AbbSum88, AbbSum139
	double complex AbbSum90, AbbSum123, AbbSum87, AbbSum19
	double complex AbbSum48, AbbSum53, AbbSum122, AbbSum102
	double complex AbbSum85, AbbSum129, AbbSum4, AbbSum141
	double complex AbbSum93, AbbSum142, AbbSum86, AbbSum94
	double complex AbbSum130, AbbSum89, AbbSum124, AbbSum106
	double complex AbbSum143, AbbSum95, AbbSum92, AbbSum140
	double complex AbbSum91, AbbSum117, AbbSum107, AbbSum118
	double complex AbbSum108, AbbSum115, AbbSum17, AbbSum113
	double complex AbbSum114, AbbSum116, AbbSum18, AbbSum25
	double complex AbbSum30, AbbSum80, AbbSum100, AbbSum20
	double complex AbbSum42, AbbSum97, AbbSum78, AbbSum98, AbbSum5
	double complex AbbSum79, AbbSum99, AbbSum1, AbbSum120
	double complex AbbSum84, AbbSum105, AbbSum82, AbbSum103
	double complex AbbSum6, AbbSum83, AbbSum104, AbbSum2, AbbSum63
	double complex AbbSum67, AbbSum110, AbbSum111, AbbSum62
	double complex AbbSum66, AbbSum64, AbbSum65, AbbSum22
	double complex AbbSum21, AbbSum23, AbbSum40, AbbSum39
	double complex AbbSum41
	common /abbrev/ Pair11, Pair12, Pair7, Pair6, Pair8, Pair10
	common /abbrev/ Pair9, Pair5, Pair3, Pair4, Pair1, Pair2
	common /abbrev/ Eps29, Eps30, Eps9, Eps25, Eps10, Eps6, Eps3
	common /abbrev/ Eps7, Eps11, Eps4, Eps12, Eps8, Eps20, Eps21
	common /abbrev/ Eps18, Eps23, Eps24, Eps19, Eps22, Eps1, Eps2
	common /abbrev/ Eps5, Eps28, Eps26, Eps13, Eps14, Eps27, Eps16
	common /abbrev/ Eps17, Eps15, Abb105, Abb112, Abb142, Abb117
	common /abbrev/ Abb34, Abb68, Abb70, Abb54, Abb137, Abb92
	common /abbrev/ Abb170, Abb136, Abb99, Abb115, Abb17, Abb28
	common /abbrev/ Abb33, Abb50, Abb141, Abb76, Abb161, Abb140
	common /abbrev/ Abb39, Abb58, Abb118, Abb56, Abb106, Abb113
	common /abbrev/ Abb143, Abb52, Abb63, Abb21, Abb1, Abb26
	common /abbrev/ Abb11, Abb132, Abb81, Abb130, Abb2, Abb87
	common /abbrev/ Abb133, Abb144, Abb3, Abb8, Abb89, Abb14
	common /abbrev/ Abb135, Abb82, Abb134, Abb4, Abb111, Abb154
	common /abbrev/ Abb114, Abb107, Abb145, Abb146, Abb108, Abb122
	common /abbrev/ Abb83, Abb37, Abb49, Abb73, Abb75, Abb158
	common /abbrev/ Abb98, Abb174, Abb175, Abb25, Abb38, Abb45
	common /abbrev/ Abb121, Abb159, Abb79, Abb181, Abb178, Abb42
	common /abbrev/ Abb61, Abb47, Abb66, Abb5, Abb103, Abb12
	common /abbrev/ Abb148, Abb94, Abb150, Abb23, Abb96, Abb32
	common /abbrev/ Abb167, Abb169, Abb102, Abb125, Abb36, Abb48
	common /abbrev/ Abb72, Abb74, Abb139, Abb84, Abb97, Abb173
	common /abbrev/ Abb138, Abb24, Abb20, Abb44, Abb119, Abb77
	common /abbrev/ Abb162, Abb176, Abb40, Abb59, Abb46, Abb64
	common /abbrev/ Abb22, Abb30, Abb93, Abb165, Abb6, Abb95
	common /abbrev/ Abb15, Abb152, Abb104, Abb155, Abb101, Abb123
	common /abbrev/ Abb85, Abb126, Abb86, Abb10, Abb128, Abb147
	common /abbrev/ Abb9, Abb127, Abb129, Abb91, Abb35, Abb69
	common /abbrev/ Abb71, Abb55, Abb157, Abb171, Abb172, Abb100
	common /abbrev/ Abb116, Abb18, Abb29, Abb19, Abb51, Abb57
	common /abbrev/ Abb53, Abb7, Abb110, Abb131, Abb88, Abb27
	common /abbrev/ Abb90, Abb166, Abb109, Abb160, Abb80, Abb179
	common /abbrev/ Abb43, Abb62, Abb67, Abb13, Abb149, Abb151
	common /abbrev/ Abb168, Abb120, Abb180, Abb78, Abb163, Abb177
	common /abbrev/ Abb41, Abb60, Abb65, Abb31, Abb164, Abb16
	common /abbrev/ Abb153, Abb156, Abb124, AbbSum138, AbbSum127
	common /abbrev/ AbbSum154, AbbSum44, AbbSum131, AbbSum148
	common /abbrev/ AbbSum144, AbbSum10, AbbSum7, AbbSum147
	common /abbrev/ AbbSum24, AbbSum29, AbbSum13, AbbSum12
	common /abbrev/ AbbSum9, AbbSum11, AbbSum45, AbbSum43
	common /abbrev/ AbbSum38, AbbSum37, AbbSum35, AbbSum36
	common /abbrev/ AbbSum16, AbbSum14, AbbSum15, AbbSum8, AbbSum3
	common /abbrev/ AbbSum34, AbbSum51, AbbSum49, AbbSum50
	common /abbrev/ AbbSum47, AbbSum28, AbbSum152, AbbSum151
	common /abbrev/ AbbSum136, AbbSum56, AbbSum134, AbbSum149
	common /abbrev/ AbbSum150, AbbSum125, AbbSum132, AbbSum135
	common /abbrev/ AbbSum133, AbbSum54, AbbSum55, AbbSum52
	common /abbrev/ AbbSum76, AbbSum126, AbbSum26, AbbSum27
	common /abbrev/ AbbSum137, AbbSum153, AbbSum145, AbbSum146
	common /abbrev/ AbbSum75, AbbSum74, AbbSum73, AbbSum112
	common /abbrev/ AbbSum70, AbbSum72, AbbSum71, AbbSum69
	common /abbrev/ AbbSum68, AbbSum33, AbbSum61, AbbSum109
	common /abbrev/ AbbSum60, AbbSum58, AbbSum59, AbbSum31
	common /abbrev/ AbbSum32, AbbSum57, AbbSum77, AbbSum46
	common /abbrev/ AbbSum121, AbbSum128, AbbSum101, AbbSum81
	common /abbrev/ AbbSum119, AbbSum96, AbbSum88, AbbSum139
	common /abbrev/ AbbSum90, AbbSum123, AbbSum87, AbbSum19
	common /abbrev/ AbbSum48, AbbSum53, AbbSum122, AbbSum102
	common /abbrev/ AbbSum85, AbbSum129, AbbSum4, AbbSum141
	common /abbrev/ AbbSum93, AbbSum142, AbbSum86, AbbSum94
	common /abbrev/ AbbSum130, AbbSum89, AbbSum124, AbbSum106
	common /abbrev/ AbbSum143, AbbSum95, AbbSum92, AbbSum140
	common /abbrev/ AbbSum91, AbbSum117, AbbSum107, AbbSum118
	common /abbrev/ AbbSum108, AbbSum115, AbbSum17, AbbSum113
	common /abbrev/ AbbSum114, AbbSum116, AbbSum18, AbbSum25
	common /abbrev/ AbbSum30, AbbSum80, AbbSum100, AbbSum20
	common /abbrev/ AbbSum42, AbbSum97, AbbSum78, AbbSum98
	common /abbrev/ AbbSum5, AbbSum79, AbbSum99, AbbSum1
	common /abbrev/ AbbSum120, AbbSum84, AbbSum105, AbbSum82
	common /abbrev/ AbbSum103, AbbSum6, AbbSum83, AbbSum104
	common /abbrev/ AbbSum2, AbbSum63, AbbSum67, AbbSum110
	common /abbrev/ AbbSum111, AbbSum62, AbbSum66, AbbSum64
	common /abbrev/ AbbSum65, AbbSum22, AbbSum21, AbbSum23
	common /abbrev/ AbbSum40, AbbSum39, AbbSum41

	double complex cint1(3), cint2(3), cint3(3), cint4(3)
	double complex cint5(3), cint6(3), cint7(3), cint8(3)
	double complex cint9(3), cint10(3), cint11(3), cint12(3)
	double complex cint13, cint14, cint15, cint16, cint17, cint18
	double complex cint19, cint20, cint21, cint22, cint23, cint24
	double complex cint25, cint26, cint27, cint28, cint29, cint30
	double complex cint31, cint32
	common /loopint/ cint1, cint2, cint3, cint4, cint5, cint6
	common /loopint/ cint7, cint8, cint9, cint10, cint11, cint12
	common /loopint/ cint13, cint14, cint15, cint16, cint17
	common /loopint/ cint18, cint19, cint20, cint21, cint22
	common /loopint/ cint23, cint24, cint25, cint26, cint27
	common /loopint/ cint28, cint29, cint30, cint31, cint32

	integer iint1, iint2, iint3, iint4, iint5, iint6, iint7, iint8
	integer iint9, iint10, iint11, iint12, iint13, iint14, iint15
	integer iint16, iint17, iint18, iint19, iint20, iint21, iint22
	integer iint23, iint24, iint25, iint26, iint27, iint28, iint29
	integer iint30, iint31, iint32, iint33, iint34, iint35
	integer iint36(3), iint37(3), iint38(3), iint39(3), iint40
	integer iint41, iint42, iint43, iint44, iint45, iint46, iint47
	integer iint48, iint49, iint50, iint51
	common /loopint/ iint1, iint2, iint3, iint4, iint5, iint6
	common /loopint/ iint7, iint8, iint9, iint10, iint11, iint12
	common /loopint/ iint13, iint14, iint15, iint16, iint17
	common /loopint/ iint18, iint19, iint20, iint21, iint22
	common /loopint/ iint23, iint24, iint25, iint26, iint27
	common /loopint/ iint28, iint29, iint30, iint31, iint32
	common /loopint/ iint33, iint34, iint35, iint36, iint37
	common /loopint/ iint38, iint39, iint40, iint41, iint42
	common /loopint/ iint43, iint44, iint45, iint46, iint47
	common /loopint/ iint48, iint49, iint50, iint51

	integer Gen1
	common /indices/ Gen1

	double complex Cloop(16), Ctree(7), MatF(16,7)
	common /coeff/ Cloop, Ctree, MatF
